/***************************************************************************
 *   Copyright (C) 2006 by bysk                                           *
 *   buysk@pf.pl                                                       *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef LED_NOTIFY_H
#define LED_NOTIFY_H

#include <qobject.h>
#include <qtimer.h>

#include "configuration_aware_object.h"
#include "config_file.h"
#include "debug.h"
//#include "chat.h"
#include "pending_msgs.h"
#include "modules/notify/notify.h"

class ChatWidget;

class LedBlinking : public QObject, ConfigurationAwareObject
{
	Q_OBJECT
	
	public:
		LedBlinking();
		~LedBlinking();
		
		void startInfinite();
		void startFinite();
		void stop();
		
		bool enabled() const	{ return enabled_; }
		
	private:
		static void setLed( int led, bool highlight );
		virtual void configurationUpdated();
		
	private slots:
		void blink(void);
		
	private:
		QTimer* timer_;
		bool value_;
		bool enabled_;
		bool countdown_;
		int delay_;
		int blinkCount_;
		int counter_;
	
};

class LedNotify : public Notifier, ConfigurationUiHandler
{
	Q_OBJECT
	
	public:
		LedNotify(QObject* parent = 0, const char* name = 0);
		~LedNotify();
		
		virtual void copyConfiguration( const QString &fromEvent, const QString &toEvent ) {}
		virtual void mainConfigurationWindowCreated(MainConfigurationWindow*) {}
		virtual NotifierConfigurationWidget* createConfigurationWidget(QWidget*, char*);
		virtual void notify( Notification *notification );

	private:
		LedBlinking blinking_;
		QValueList<ChatWidget*> msgChats_;
		
	private slots:
		void messageReceived( UserListElement user );

};

#endif // LED_NOTIFY_H
