/***************************************************************************
 *   Copyright (C) 2006 by bysk                                           *
 *   buysk@pf.pl                                                       *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef LED_NOTIFY_H
#define LED_NOTIFY_H

#include <qobject.h>
#include <qtimer.h>

#include "config_file.h"
#include "debug.h"
//#include "chat.h"
#include "pending_msgs.h"
#include "modules/notify/notify.h"

class ChatWidget;

class LedNotify : public Notifier, ConfigurationUiHandler
{
	Q_OBJECT
	
	public:
		LedNotify(QObject* parent = 0, const char* name = 0);
		~LedNotify();
		
		virtual void copyConfiguration( const QString &fromEvent, const QString &toEvent ) {}
		virtual void mainConfigurationWindowCreated(MainConfigurationWindow*);
		virtual NotifierConfigurationWidget* createConfigurationWidget(QWidget*, char*);
		virtual void notify( Notification *notification );
	
	private:
		void newChat();
		void newMessage( const UserListElements& senders );

	private:
		QTimer* timer;
		bool ledHighlight_;
		bool blinking_;
		bool stopBlinkingFromChat_;
		bool stopBlinkingFromMsg_;
		QValueList<ChatWidget*> msgChats_;
		ChatWidget* activeChat_;
		
		QMap<UserListElements, QString> currentEvents_;
		
		static void setLed( int led, bool highlight );
		
		static int NUMLOCK_LED;
		static int CAPSLOCK_LED;
		static int SCROLLLOCK_LED;
		
	private slots:
		void blink(void);
		void chatWidgetActivated( ChatWidget* chat );
		void messageReceived( UserListElement user );
		void notificationClosed(Notification *);

};

#endif // LED_NOTIFY_H
